import QtQuick
import "../provider"

MouseArea {
    id: mouse

    property string text: ""

    cursorShape: Qt.PointingHandCursor

    hoverEnabled: true

    BRectangle {
        id: self
        anchors.centerIn: parent

        Text {
            visible: mouse.text?.length > 0
            text: mouse.text
            anchors.centerIn: parent
        }

        states: [
            State {
                name: "moved"
                when: mouse.containsMouse && !mouse.pressed
                PropertyChanges {
                    target: self
                    width: (mouse.width < mouse.height ? mouse.width : mouse.height) * 1.1
                    height: (mouse.width < mouse.height ? mouse.width : mouse.height) * 1.1
                }
            },
            State {
                name: "clicked"
                when: mouse.pressed
                PropertyChanges {
                    target: self
                    width: (mouse.width < mouse.height ? mouse.width : mouse.height) * 0.9
                    height: (mouse.width < mouse.height ? mouse.width : mouse.height) * 0.9
                }
            }
        ]

        transitions: Transition {
            NumberAnimation {
                properties: "width,height"
                easing.type: Easing.OutBack
                easing.overshoot: 5
                duration: 200
            }
        }
    }
}
